/*
 *  LOKI91
 */

#include <stdio.h>

/*i󒍁Fł Intel 386 vZbT
 *  RpC邱Ƃz肵ĂB
 *  PowerPC Ȃǂ̃rbOGfBA@
 *  RpCꍇ́Aȉ̒` #undef 邱ƁBj
 */
#define LITTLE_ENDIAN

#ifdef LITTLE_ENDIAN
#define bswap(cb) {                                         \
                    register char   c;                      \
                    c = cb[0]; cb[0] = cb[3]; cb[3] = c;    \
                    c = cb[1]; cb[1] = cb[2]; cb[2] = c;    \
                    c = cb[4]; cb[4] = cb[7]; cb[7] = c;    \
                    c = cb[5]; cb[5] = cb[6]; cb[6] = c;    \
                  }
#endif

#define LOKIBLK         8       /* LOKIf[^ubÑoCg */
#define ROUNDS          16      /* LOKĨEh */

typedef unsigned long Long;     /* ACgꂽLOKIubŇ^ */

typedef struct {
    Long loki_subkeys[ROUNDS];
} loki_ctx;

typedef struct {
    short gen;                  /* ̗̈Ŏg񑽍 */
    short exp;                  /*  s ֐𐶐ƂɎgw */
} sfn_desc;

extern char *loki_lib_ver;      /* o[Wԍcopyright̂߂̕ */

char P[32] = {
    31, 23, 15, 7, 30, 22, 14, 6,
    29, 21, 13, 5, 28, 20, 12, 4,
    27, 19, 11, 3, 26, 18, 10, 2,
    25, 17,  9, 1, 24, 16,  8, 0
};

sfn_desc sfn[] = {
    { /* 101110111 */ 375, 31}, { /* 101111011 */ 379, 31},
    { /* 110000111 */ 391, 31}, { /* 110001011 */ 395, 31},
    { /* 110001101 */ 397, 31}, { /* 110011111 */ 415, 31},
    { /* 110100011 */ 419, 31}, { /* 110101001 */ 425, 31},
    { /* 110110001 */ 433, 31}, { /* 110111101 */ 445, 31},
    { /* 111000011 */ 451, 31}, { /* 111001111 */ 463, 31},
    { /* 111010111 */ 471, 31}, { /* 111011101 */ 477, 31},
    { /* 111100111 */ 487, 31}, { /* 111110011 */ 499, 31},
    { 00, 00 }
};

static Long f();                /* LOKI֐ f ̐錾 */
static short s();               /* LOKI S{bNX֐ s */

#define ROL12(b) b = ((b << 12) | (b >> 20));
#define ROL13(b) b = ((b << 13) | (b >> 19));

void setlokikey(loki_ctx *c, char *key)
{
    register int i;
    register Long KL, KR;

#ifdef LITTLE_ENDIAN
    /* gGfBÂƂ̓oCg𔽓] */
    bswap(key);
#endif
    KL = ((Long *)key)[0];
    KR = ((Long *)key)[1];

    /* 16̃Tu𐶐 */
    for (i = 0; i < ROUNDS; i += 4) {
        c->loki_subkeys[i] = KL;
        ROL12 (KL);
        c->loki_subkeys[i+1] = KL;
        ROL13 (KL);
        c->loki_subkeys[i+2] = KR;
        ROL12 (KR);
        c->loki_subkeys[i+3] = KR;
        ROL13 (KR);
    }

#ifdef LITTLE_ENDIAN
    /* gGfBÂƂ͔]oCgƂɖ߂ */
    bswap(key);
#endif
}

void enloki (loki_ctx *c, char *b)
{
    register int i;
    register Long L, R;         /* Eɕf[^ */

#ifdef LITTLE_ENDIAN
    /* gGfBÂƂ̓oCg𔽓] */
    bswap(b);
#endif
    L = ((Long *)b)[0];
    R = ((Long *)b)[1];

    /* 16̃TuňÍ */
    for (i = 0; i < ROUNDS; i += 2) {
        L ^= f(R, c->loki_subkeys[i]);
        R ^= f(L, c->loki_subkeys[i+1]);
    }

    /* Y = swap(LR) */
    ((Long *)b)[0] = R;
    ((Long *)b)[1] = L;

#ifdef LITTLE_ENDIAN
    /* gGfBÂƂ͔]oCgƂɖ߂ */
    bswap(b);
#endif
}

void deloki(loki_ctx *c, char *b)
{
    register int i;
    register Long L, R;         /* Eɕf[^ */

#ifdef LITTLE_ENDIAN
    /* gGfBÂƂ̓oCg𔽓] */
    bswap(b);
#endif

    /* LR = X XOR K */
    L = ((Long *)b)[0];
    R = ((Long *)b)[1];

    /* Tut̏ */
    for (i = ROUNDS; i > 0; i -= 2) {
        L ^= f(R, c->loki_subkeys[i-1]);
        R ^= f(L, c->loki_subkeys[i-2]);
    }

    /* Y = LR XOR K */
    ((Long *)b)[0] = R;
    ((Long *)b)[1] = L;
}

#define MSB     0x80000000L     /* 32rbg[h MSB */

void perm32(Long *out,  /* בւ32rbg̃ubNo */
            Long *in,   /* בւꂽƂ32rbg̃ubN */
            char perm[32])      /* p̔z */
{
    Long mask = MSB;            /* o͂Ńrbg𗧂Ă̂Ɏg}XN */
    register int i, o, b;       /* ̓rbgԍAo̓rbgԍAl */
    register char *p = perm;    /* p̔zw|C^  */

    /* o̓ubNNAĂ */
    *out = 0;
    /* o Ԗڂ̊eo̓rbgɂ */
    for (o = 0; o < 32; o++) {
        i = (int)*p++;          /* o o ɑgݍ܂̓rbg𓾂 */
        b = (*in >> i) & 01;    /* ̓rbg i ̒l */
        if (b)                  /*  i Ԗڂ̓̓rbgĂ */
            *out |= mask;       /* o i Ƀ}XNOR */
        mask >>= 1;             /* }XÑrbgɃVtg */
    }
}

#define SIZE 256                /* KA GF(2^8) ɂ256̗vf */

short mult8(short a, short b,   /* Zp̃Iyh */
            short gen)          /* KÂ𐶐񑽍 */
{
    short product = 0;          /* Ž */

    while(b != 0) {             /* 搔[łȂ */
        if (b & 01)
            product ^= a;       /* b  LSB ĂΔ搔 */
        a <<= 1;                /* 搔ЂƂVtg */
        if (a >= SIZE)
            a ^= gen;           /* KvȂ΃W */
        b >>= 1;                /* 搔ЂƂVtg  */
    }
    return product;
}

/* KA GF(2^8) ɂׂ惋[` */
short exp8(short base,          /* ׂ̒ */
           short exponent,      /* ׂw */
           short gen)           /* KÂ𐶐񑽍 */
{
    short accum = base;         /* ̒ */
    short result = 1;           /* ׂ̌ */

    if (base == 0)              /* Ƃă[w肳ĂȂ */
        return 0;               /* ʂ "0" */

    while (exponent != 0) {     /* ׂw[łȂ */
        if ((exponent & 0x0001) == 0x0001) /* exp 1 Ȃ| */
            result = mult8(result, accum, gen);
        exponent >>= 1;         /* ׂw̌ɃVtg */
        accum = mult8(accum, accum, gen); /* Ď */
    }

    return result;
}

#define MASK12    0x0fff        /* E ̓WĴ߂12rbg̃}XN */

static Long f(register Long r,  /* f[^ R(i-1) */
              Long k)           /*      K(i)   */
{
    Long a, b, c;        /* 32rbg S{bNXóA P o */

    /* A = R(i-1) XOR K(i) */
    a = r ^ k;

    /* xxĂTCỸo[Wg
     * B = S(E(R(i-1))^K(i))
     */
    b = ((Long)s((a         & MASK12))      ) |
        ((Long)s(((a >>  8) & MASK12)) <<  8) |
        ((Long)s(((a >> 16) & MASK12)) << 16) |
        ((Long)s((((a >> 24) | (a << 8)) & MASK12)) << 24);

    /* C = P(S(E(R(i-1)) XOR K(i))) */
    perm32(&c, &b, P);

    /* f ͌ C Ԃ */
    return c;
}

/*  i ɑ΂S{bNX̒lԂ */
static short s(register Long i)
{
    register short r, c, v, t;

    r = ((i>>8) & 0xc) | (i & 0x3);     /* s̒lFォ2Ɖ2 */
    c = (i>>2) & 0xff;                  /* ̒lF^񒆂8rbg */
    t = (c + ((r * 17) ^ 0xff)) & 0xff; /* S֐̊l */
    v = exp8(t, sfn[r].exp, sfn[r].gen); /* Sfn[r] = t ^ exp mod gen */
    return v;
}

void loki_key(loki_ctx *c, unsigned char *key)
{
    setlokikey(c, key);
}

void loki_enc(loki_ctx *c, unsigned char *data, int blocks)
{
    unsigned char *cp;
    int i;

    cp = data;
    for (i = 0; i < blocks; i++) {
        enloki(c, cp);
        cp += 8;
    }
}

void loki_dec(loki_ctx *c, unsigned char *data, int blocks)
{
    unsigned char *cp;
    int i;

    cp = data;
    for (i = 0; i < blocks; i++) {
        deloki(c, cp);
        cp += 8;
    }
}

int main(int argc, char* argv[])
{
    loki_ctx lc;
    unsigned long data[10];
    unsigned char *cp;
    unsigned char key[] = {0, 1, 2, 3, 4, 5, 6, 7};
    int i;

    for (i = 0; i < 10; i++)
        data[i] = i;

    loki_key(&lc, key);
    cp = (char *)data;

    loki_enc(&lc, cp, 5);
    for (i = 0; i < 10; i += 2) {
        printf("Block %01d = %08lx %08lx\n",
               i/2, data[i], data[i+1]);
    }

    loki_dec(&lc, cp, 1);
    loki_dec(&lc, cp+8, 4);
    for (i = 0; i < 10; i += 2) {
        printf("Block %01d = %08lx %08lx\n",
               i/2, data[i], data[i+1]);
    }

    return 0;
}
